# ========================================================================= #
#   PLATFORM                                                                #
# ========================================================================= #

wd.iphone = Ti.Platform.osname == "iphone"
wd.android = Ti.Platform.osname == "android"

wd.os = (map) ->
  osname = Ti.Platform.osname
  def = map.def || null
  if typeof map[osname] != "undefined"
    if typeof map[osname] == "function"
      return map[osname]()
    else
      return map[osname]
  else
    if typeof def == "function"
      return def()
    else
      return def


# ========================================================================= #
#   APP SHORTFORMS                                                          #
# ========================================================================= #

wd.getstr = (name) -> Ti.App.Properties.getString(name)
wd.getarr = (name) -> Ti.App.Properties.getList(name)
wd.getint = (name) -> Ti.App.Properties.getInt(name)
wd.getbool = (name) -> Ti.App.Properties.getBool(name)

wd.setstr = (name, val) -> Ti.App.Properties.setString(name, val)
wd.setarr = (name, val) -> Ti.App.Properties.setList(name, val)
wd.setint = (name, val) -> Ti.App.Properties.setInt(name, val)
wd.setbool = (name, val) -> Ti.App.Properties.setBool(name, val)

wd.clear = (name) -> Ti.App.Properties.removeProperty(name)

wd.info = (text) -> Ti.API.info "<br/><span style=\"color: #393;\">#{text}</span>"
wd.debug = (text) -> Ti.API.debug "<br/><span style=\"color: #933;\">#{text}</span>"


# ========================================================================= #
#   UTILITY                                                                 #
# ========================================================================= #

wd.timestamp_to_unix = (datetime) ->
  Math.round(Date.parse(datetime.replace(/-/ig, "/").replace(/T|z/ig, " ") + "UTC")/1000)
  
wd.errMsg = (xhr) ->
  if xhr.responseText
    if JSON.parse(xhr.responseText).message
      return JSON.parse(xhr.responseText).message
    else if JSON.parse(xhr.responseText).errors
      return JSON.parse(xhr.responseText).errors.join(", ")
  else
    return "An error has occurred. Please try again later."

wd.rjust = (number, width) ->
  width -= number.toString().length
  if width > 0
    width += if /\./.test(number) then 2 else 1
    return new Array(width).join("0") + number
  return number


# ========================================================================= #
#   UNDERSCORE                                                              #
# ========================================================================= #

_.filter_obj = (list, iterator) ->
  new_obj = {}
  for k, v of list
    if iterator(v, k)
      new_obj[k] = v
  return new_obj

  
  
  