class wd.ActiveRecord

  # ========================================================================= #
  #   MODEL                                                                   #
  # ========================================================================= #
  
  @configure: (name) ->
    @className = name
    @db_table = name.toLowerCase() + "s"
    this

  @attr_accessible: (attributes) ->
    @attributes = attributes
    this

  # ========================================================================= #
  #   INSTANCE                                                                #
  # ========================================================================= #

  validate: ->

  validates = ->
    error = @validate()
    
  
  save: ->
    if this.validates()
      attr_acc = @model.attr_accessible
      attr = _.filter_obj(this, (v, k) -> 
        _.include(attr_acc, k))
      keys = _.keys(attr).join(", ")
      values = _.values(attr)
      marks = _.map(values, -> "?").join(", ")
      db = if wd.db.tsOpen then wd.db.ts else Ti.Database.open(wd.db_name)
      db.execute "INSERT INTO #{@db_table} (#{keys}) VALUES (#{marks})", values
      db.close() unless wd.db.tsOpen
      return true
    else
      return false
      
  update: (args = {}) ->
    frag = _.chain(args).keys().map((k) -> k + " = ?").value().join(", ")
    params = _.values(args)
    params.push @id
    db = Ti.Database.open(wd.db_name)
    db.execute "UPDATE #{@db_table} SET #{frag} WHERE id = ?", params
    db.close()
  
  destroy: ->
    db = Ti.Database.open(wd.db_name)
    db.execute "DELETE FROM #{@db_table} WHERE id = ?", @id
    db.close()


  # ========================================================================= #
  #   METHODS                                                                 #
  # ========================================================================= #

  this.find = (id) ->
    rows = wd.db.get "SELECT * FROM #{@db_table} WHERE id = ?", [id]
    this.objectify(rows)

  this.first = ->
    rows = wd.db.get "SELECT * FROM #{@db_table} ORDER BY id ASC LIMIT 1"
    this.objectify(rows)

  this.last = ->
    rows = wd.db.get "SELECT * FROM #{@db_table} ORDER BY id DESC LIMIT 1"
    this.objectify(rows)

  this.count = ->
    db = Ti.Database.open(wd.db_name)
    result = db.execute("SELECT COUNT(*) FROM #{@db_table}")
    count = result.field(0)
    result.close()
    db.close()
    return count

  this.all = ->
    rows = wd.db.get "SELECT * FROM #{@db_table}"
    this.objectify_many(rows)
  
  this.where = (where_frag, args = []) ->
    rows = wd.db.get "SELECT * FROM #{@db_table} WHERE #{where_frag}", args
    this.objectify_many(rows)
    

  # ========================================================================= #
  #   PRIVATE METHODS                                                         #
  # ========================================================================= #

  this.objectify = (rows) ->
    if _.isEmpty(rows)
      return false
    else
      obj = new this
      for key of rows[0]
        obj[key] = rows[0][key]
      return obj

  this.objectify_many = (rows) ->
    objs = []
    unless _.isEmpty(rows)
      for row in rows
        obj = new this
        for key of row
          obj[key] = row[key]
        objs.push obj
    return objs
  
