class wd.Tale extends wd.Steel.Model
  @configure "Tale"
  @attr_accessible "remote_id", "title", "synced", "last_pull", "created_at", "updated_at"
  
  validate: ->
    unless @title
      "Please fill in a title" 
    else if @title.length < 3
      "Please enter a longer title (> 3 characters)" 
    else if @title.length > 30
      "Title length too long (< 30 characters)"
      

  # ========================================================================= #
  #   ASSOCIATIONS                                                            #
  # ========================================================================= #

  photos: ->
    rows = wd.db.get "SELECT * FROM photos WHERE tale_id = ? OR remote_tale_id = ? ORDER BY updated_at DESC", [@id, @remote_id]
    wd.Steel.objectify_many(rows, wd.Photo)
    