wd.net =
  queue: []
  
# ========================================================================= #
#   POST & GET METHODS                                                      #
# ========================================================================= #

wd.net.post = (url, params, _cb = {}) ->
  send_http("POST", url, _cb, params)
  
wd.net.get = (url, _cb = {}, params) ->
  send_http("GET", url, _cb, params)

send_http = (method, url, _cb = {}, params) ->
  if Ti.App.Properties.hasProperty("token") || url.match(/tokens/) || url.match(/sign_up/)
    
    xhr = Titanium.Network.createHTTPClient()

    xhr.onload = -> 
      _cb._s(this, params) if _cb._s
    xhr.onerror = ->
      _cb._f(this) if _cb._f
    xhr.onsendstream = (e) ->
      # _cb.onsendstream(e) if _cb.onsendstream

    op = if url.match(/\?/) then "&" else "?"
    
    xhr.open method, "#{wd.server_url}/#{url}#{op}auth_token=#{wd.getstr("token")}"
    if method == "POST" && not _cb.onsendstream
      xhr.setRequestHeader "content-type", "application/json"

    params = JSON.stringify(params) if method == "POST" && not _cb.onsendstream

    if method == "GET"
      xhr.send()
    else
      xhr.send params

  else
    wd.info "Adding to queue: #{method} #{url}"
    wd.net.queue.push 
      method: method
      url: url
      _cb: _cb
      params: params
    

wd.net.retry = ->
  for q in wd.net.queue
    wd.net.send_http(q.method, q.url, q._cb, q.params)

