wd.ui.tabs = {}

# ========================================================================= #
#   NAVBAR                                                                  #
# ========================================================================= #
  
createMenuBtn = ->
  menuBtn = Ti.UI.createButton _.extend wd.s.menuBtn
  menuBtn.addEventListener "click", (e) ->
    wd.ui.toggleMenu()
  return menuBtn

createAddBtn = ->
  addBtn = Ti.UI.createButton _.extend wd.s.addBtn
  addBtn.addEventListener "click", (e) ->
    wd.photos.index()
  return addBtn

# iPhone  
wd.ui.addNavBtnsTo = (win) ->
  menuBtn = createMenuBtn()
  addBtn = createAddBtn()
  win.setLeftNavButton menuBtn
  win.setRightNavButton addBtn
  return win  


# ========================================================================= #
#   MAIN CONTAINER                                                          #
# ========================================================================= #

# iPhone
wd.ui.createMainTabGroup = ->
  tabGroup = Ti.UI.createTabGroup()

  for routeName, route of wd.routes
    wd.ui[routeName + "Tab"] = Ti.UI.createTab
      window: route.window()
      tabNum: route.num
    tabGroup.addTab wd.ui[routeName + "Tab"]

  return tabGroup


# Android
wd.ui.createMainView = ->
  view = Ti.UI.createView
    backgroundColor: "#fff"
    zIndex: 2

  wd.ui.navBar = Ti.UI.createView _.extend wd.s.navBar_a
  menuBtn = createMenuBtn()
  wd.ui.addBtn = createAddBtn()
  wd.ui.navTitle = Ti.UI.createLabel _.extend wd.s.navTitle_a,
    text: "Home"

  wd.ui.navBar.add menuBtn
  wd.ui.navBar.add wd.ui.addBtn
  wd.ui.navBar.add wd.ui.navTitle

  view.add wd.ui.navBar

  wd.ui.tabs.home = wd.ui.createHomeWindow()
  view.add wd.ui.tabs.home
  
  return view
  

# ========================================================================= #
#   SHOW MAIN                                                               #
# ========================================================================= #

wd.ui.showMain = ->
  wd.ui.menu = wd.ui.createMenu()
  wd.ui.menu.open()

  wd.home.loadHome()

  if wd.iphone 
    wd.ui.mainContainer = wd.ui.createMainTabGroup()
    wd.ui.mainContainer.open()
  else
    wd.ui.mainContainer = wd.ui.createMainView()
    wd.ui.menu.add wd.ui.mainContainer
    wd.ui.initBackButton()

  wd.ui.menu.show()  
  wd.ui.initContainer.close() if wd.ui.initContainer


wd.ui.initBackButton = ->
  wd.history = [wd.ui.tabs.home]
  
  wd.ui.menu.addEventListener "android:back", ->
    if wd.ui.menuOpen
      wd.ui.toggleMenu("close")
    else
      if wd.history.length <= 1 
        wd.ui.menu.close()
        Ti.Android.currentActivity.finish()
      else
        currView = wd.history.pop()
        prevView = _.last(wd.history)
        prevView.show()
        currView.hide()
        
