
# ========================================================================= #
#   MENU WINDOW                                                             #
# ========================================================================= #

wd.ui.createMenu = ->
  win = Ti.UI.createWindow
    tabBarHidden: true
    navBarHidden: true
    visible: false
    activity:
      onPrepareOptionsMenu: (e) ->    
        wd.ui.toggleMenu("open")
        
  menuTable = Ti.UI.createTableView
    data: _(wd.routes).reject (route) -> route.menu == false

  menuTable.addEventListener "click", (e) ->
    e.rowData.route()
  
  wd.ui.menuShadow = Ti.UI.createImageView
    image: "/img/menushadow.png"
    width: 10
    height: 480
    top: 0
    left: -10   
    
  if wd.iphone
    win.add menuTable
    win.add wd.ui.menuShadow
  else
    view = Ti.UI.createView
      zIndex: 0
    view.add menuTable
    view.add wd.ui.menuShadow
    win.add view
  
  return win


# ========================================================================= #
#   TOGGLE MENU                                                             #
# ========================================================================= #

wd.ui.menuOpen = false

wd.ui.toggleMenu = (direction) ->
  if wd.ui.menuOpen || direction == "close"
    wd.ui.menuShadow.animate
      left: -10
      duration: 300
    wd.ui.mainContainer.animate
      left: 0
      top: 0
      width: 320  
      duration: 300
    wd.ui.menuOpen = false
    if wd.iphone
      wd.ui.mainContainer.activeTab.window.remove wd.ui.closeMenuBtn if wd.ui.closeMenuBtn
    else
      wd.ui.mainContainer.remove wd.ui.closeMenuBtn if wd.ui.closeMenuBtn

  else if not wd.ui.menuOpen || direction == "open"
    wd.ui.menuShadow.animate
      left: 265
      duration: 300
    wd.ui.mainContainer.animate
      left: 275
      top: 0
      width: 320
      duration: 300
    wd.ui.menuOpen = true
    
    wd.ui.closeMenuBtn = Ti.UI.createView
      zIndex: 99
      width: 45
      height: 480
      top: 0
      left: 0
    wd.ui.closeMenuBtn.addEventListener "click", ->
      wd.ui.toggleMenu("close")
      
    if wd.iphone
      wd.ui.mainContainer.activeTab.window.add wd.ui.closeMenuBtn
    else
      wd.ui.mainContainer.add wd.ui.closeMenuBtn
  

# ========================================================================= #
#   TABS / WINDOW SWITCHING                                                 #
# ========================================================================= #

wd.ui.showTab = (tab) ->
  wd.info "Showing tab #{tab}"
  if wd.iphone
    wd.ui.mainContainer.setActiveTab(wd.ui["#{tab}Tab"].tabNum)
  else
    if wd.ui.tabs[tab]
      wd.ui.tabs[tab].show()
    else
      wd.info "Tab not found. Creating #{tab}"
      wd.ui.tabs[tab] = wd.routes[tab].window()
      wd.ui.mainContainer.add wd.ui.tabs[tab]
      
    wd.ui.navTitle.text = wd.ui.tabs[tab].title
    
    for tabName, tabView of wd.ui.tabs
      tabView.hide() unless tabName == tab

    wd.ui.updateNavBar(tab)
    wd.history.push wd.ui.tabs[tab]

  # Close/hide modal windows
  if wd.ui.taleShowWin
    if wd.iphone then wd.ui.taleShowWin.close() else wd.ui.taleShowWin.hide()

  wd.ui.toggleMenu("close")
    
  
wd.ui.openWin = (win, tab) ->
  if wd.iphone
    tab.open(win)
  else
    wd.ui.mainContainer.add win
    wd.ui.updateNavBar(win.title)
    wd.history.push win    

  
wd.ui.updateNavBar = (title) ->
  wd.ui.addBtn.show()
  wd.ui.newTaleBtn.hide() if wd.ui.newTaleBtn

  switch title
    when "tales"
      wd.ui.newTaleBtn.show() if wd.ui.newTaleBtn
      wd.ui.addBtn.hide()


  