(function() {
  var Tales,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

  Tales = (function() {

    function Tales() {
      this.index = __bind(this.index, this);
    }

    Tales.prototype.index = function() {
      wd.ui.showTab("tales");
      this.push();
      return this.pull();
    };

    Tales.prototype["new"] = function() {
      wd.ui.addTaleWin = wd.ui.createAddTaleWindow();
      return wd.ui.openWin(wd.ui.addTaleWin, wd.ui.talesTab);
    };

    Tales.prototype.show = function(tale) {
      wd.shownTale = tale;
      if (wd.android) wd.ui.navTitle.text = tale.title;
      wd.ui.taleShowWin = wd.ui.createTaleShowWindow();
      wd.ui.openWin(wd.ui.taleShowWin, wd.ui.talesTab);
      wd.photos.push();
      return wd.photos.pull(tale);
    };

    Tales.prototype.create = function(params) {
      var tale;
      tale = wd.Tale.create(params);
      if (tale) {
        this.push();
        this.pull();
        wd.setint("currentTale", +wd.Tale.last().id);
        return wd.ui.addTaleWin.close();
      }
    };

    Tales.prototype.tales = function() {
      var tale, tales, _i, _len;
      tales = wd.Tale.all();
      for (_i = 0, _len = tales.length; _i < _len; _i++) {
        tale = tales[_i];
        tale.title = "" + tale.id + " - " + tale.remote_id + " - " + tale.title;
        if (!tale["synced"]) {
          tale.title = "" + tale.title + "*";
          tale.color = "#ccc";
        }
      }
      return tales;
    };

    Tales.prototype.pull = function() {
      var lastPull, user;
      wd.info("Pulling tales");
      lastPull = wd.getstr("talesLastPull");
      user = wd.getint("userID");
      return wd.net.get("api/tales/pull.json?since=" + lastPull + "&user=" + user, {
        _s: function(xhr) {
          var row, tale_remote_ids, _i, _len, _ref;
          wd.info("Pulled " + (_.size(JSON.parse(xhr.responseText))) + " tales");
          wd.setstr("talesLastPull", Math.round(+new Date() / 1000));
          tale_remote_ids = _(wd.Tale.all()).pluck("remote_id");
          wd.db.ts = Ti.Database.open(wd.db_name);
          wd.db.tsOpen = true;
          wd.db.ts.execute("BEGIN IMMEDIATE TRANSACTION");
          _ref = JSON.parse(xhr.responseText);
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            row = _ref[_i];
            if (!_(tale_remote_ids).include(row.id)) {
              wd.Tale.create({
                remote_id: row.id,
                title: row.title,
                created_at: row.created_at,
                updated_at: row.updated_at,
                synced: 1
              });
            } else {
              wd.Tale.where("remote_id = ?", row.id)[0].update({
                title: row.title,
                created_at: row.created_at,
                updated_at: row.updated_at
              });
            }
          }
          wd.db.ts.execute("COMMIT TRANSACTION");
          wd.db.tsOpen = false;
          wd.db.ts.close();
          return wd.ui.talesTable.refresh();
        },
        _f: function(xhr) {
          return wd.debug("Error pulling! " + (wd.errMsg(xhr)));
        }
      });
    };

    Tales.prototype.push = function() {
      var params, unsynced_tales;
      unsynced_tales = _.map(wd.Tale.where("synced = ?", 0), function(tale) {
        return wd.Steel.filter(tale, ["id", "title", "created_at", "updated_at"]);
      });
      wd.info("Pushing " + (_.size(unsynced_tales)) + " tales");
      if (unsynced_tales.length > 0) {
        params = {
          tale: unsynced_tales,
          user: {
            id: wd.getint("userID")
          }
        };
        wd.net.post("api/tales/push.json", params, {
          _s: function(xhr) {
            var errorMsg, id, val, _ref, _results;
            _ref = JSON.parse(xhr.responseText);
            _results = [];
            for (id in _ref) {
              val = _ref[id];
              if (_.has(val, "remote_id")) {
                _results.push(wd.Tale.find(id).update({
                  synced: 1,
                  remote_id: val.remote_id
                }));
              } else {
                errorMsg = val.errors.join(", ");
                _results.push(alert(errorMsg));
              }
            }
            return _results;
          },
          _f: function() {
            return wd.debug("Error pushing!");
          }
        });
        return wd.ui.talesTable.refresh();
      }
    };

    return Tales;

  })();

  wd.tales = new Tales;

}).call(this);
