(function() {

  wd.users = {};

  wd.users.login = function(username, password) {
    var params;
    params = {
      username: username,
      password: password
    };
    wd.users.clearUserProperties();
    return wd.net.post("api/tokens.json", params, {
      _s: function(xhr) {
        return wd.users.showMain(xhr);
      },
      _f: function(xhr) {
        return alert(wd.errMsg(xhr));
      }
    });
  };

  wd.users.signup = function(username, password, email) {
    var params;
    params = {
      user: {
        username: username,
        password: password,
        password_confirmation: password,
        email: email
      }
    };
    wd.users.clearUserProperties();
    return wd.net.post("api/sign_up.json", params, {
      _s: function(xhr) {
        if (xhr.status === 200) {
          alert("Signed up!");
          wd.ui.signupWin.close();
          return wd.users.showMain(xhr);
        } else {
          return alert(wd.errMsg(xhr));
        }
      },
      _f: function(xhr) {
        return alert(wd.errMsg(xhr));
      }
    });
  };

  wd.users.clearUserProperties = function() {
    wd.clear("token");
    return wd.clear("userID");
  };

  wd.users.showMain = function(xhr) {
    wd.setstr("token", JSON.parse(xhr.responseText).token);
    wd.setint("userID", +JSON.parse(xhr.responseText).user_id);
    wd.ui.showMain();
    return wd.net.retry();
  };

}).call(this);
