(function() {

  wd.iphone = Ti.Platform.osname === "iphone";

  wd.android = Ti.Platform.osname === "android";

  wd.os = function(map) {
    var def, osname;
    osname = Ti.Platform.osname;
    def = map.def || null;
    if (typeof map[osname] !== "undefined") {
      if (typeof map[osname] === "function") {
        return map[osname]();
      } else {
        return map[osname];
      }
    } else {
      if (typeof def === "function") {
        return def();
      } else {
        return def;
      }
    }
  };

  wd.getstr = function(name) {
    return Ti.App.Properties.getString(name);
  };

  wd.getarr = function(name) {
    return Ti.App.Properties.getList(name);
  };

  wd.getint = function(name) {
    return Ti.App.Properties.getInt(name);
  };

  wd.getbool = function(name) {
    return Ti.App.Properties.getBool(name);
  };

  wd.setstr = function(name, val) {
    return Ti.App.Properties.setString(name, val);
  };

  wd.setarr = function(name, val) {
    return Ti.App.Properties.setList(name, val);
  };

  wd.setint = function(name, val) {
    return Ti.App.Properties.setInt(name, val);
  };

  wd.setbool = function(name, val) {
    return Ti.App.Properties.setBool(name, val);
  };

  wd.clear = function(name) {
    return Ti.App.Properties.removeProperty(name);
  };

  wd.info = function(text) {
    return Ti.API.info("<br/><span style=\"color: #393;\">" + text + "</span>");
  };

  wd.debug = function(text) {
    return Ti.API.debug("<br/><span style=\"color: #933;\">" + text + "</span>");
  };

  wd.timestamp_to_unix = function(datetime) {
    return Math.round(Date.parse(datetime.replace(/-/ig, "/").replace(/T|z/ig, " ") + "UTC") / 1000);
  };

  wd.errMsg = function(xhr) {
    if (xhr.responseText) {
      if (JSON.parse(xhr.responseText).message) {
        return JSON.parse(xhr.responseText).message;
      } else if (JSON.parse(xhr.responseText).errors) {
        return JSON.parse(xhr.responseText).errors.join(", ");
      }
    } else {
      return "An error has occurred. Please try again later.";
    }
  };

  wd.rjust = function(number, width) {
    width -= number.toString().length;
    if (width > 0) {
      width += /\./.test(number) ? 2 : 1;
      return new Array(width).join("0") + number;
    }
    return number;
  };

  _.filter_obj = function(list, iterator) {
    var k, new_obj, v;
    new_obj = {};
    for (k in list) {
      v = list[k];
      if (iterator(v, k)) new_obj[k] = v;
    }
    return new_obj;
  };

}).call(this);
