(function() {
  var send_http;

  wd.net = {
    queue: []
  };

  wd.net.post = function(url, params, _cb) {
    if (_cb == null) _cb = {};
    return send_http("POST", url, _cb, params);
  };

  wd.net.get = function(url, _cb, params) {
    if (_cb == null) _cb = {};
    return send_http("GET", url, _cb, params);
  };

  send_http = function(method, url, _cb, params) {
    var op, xhr;
    if (_cb == null) _cb = {};
    if (Ti.App.Properties.hasProperty("token") || url.match(/tokens/) || url.match(/sign_up/)) {
      xhr = Titanium.Network.createHTTPClient();
      xhr.onload = function() {
        if (_cb._s) return _cb._s(this, params);
      };
      xhr.onerror = function() {
        if (_cb._f) return _cb._f(this);
      };
      xhr.onsendstream = function(e) {};
      op = url.match(/\?/) ? "&" : "?";
      xhr.open(method, "" + wd.server_url + "/" + url + op + "auth_token=" + (wd.getstr("token")));
      if (method === "POST" && !_cb.onsendstream) {
        xhr.setRequestHeader("content-type", "application/json");
      }
      if (method === "POST" && !_cb.onsendstream) params = JSON.stringify(params);
      if (method === "GET") {
        return xhr.send();
      } else {
        return xhr.send(params);
      }
    } else {
      wd.info("Adding to queue: " + method + " " + url);
      return wd.net.queue.push({
        method: method,
        url: url,
        _cb: _cb,
        params: params
      });
    }
  };

  wd.net.retry = function() {
    var q, _i, _len, _ref, _results;
    _ref = wd.net.queue;
    _results = [];
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      q = _ref[_i];
      _results.push(wd.net.send_http(q.method, q.url, q._cb, q.params));
    }
    return _results;
  };

}).call(this);
