(function() {
  var createAddBtn, createMenuBtn;

  wd.ui.tabs = {};

  createMenuBtn = function() {
    var menuBtn;
    menuBtn = Ti.UI.createButton(_.extend(wd.s.menuBtn));
    menuBtn.addEventListener("click", function(e) {
      return wd.ui.toggleMenu();
    });
    return menuBtn;
  };

  createAddBtn = function() {
    var addBtn;
    addBtn = Ti.UI.createButton(_.extend(wd.s.addBtn));
    addBtn.addEventListener("click", function(e) {
      return wd.photos.index();
    });
    return addBtn;
  };

  wd.ui.addNavBtnsTo = function(win) {
    var addBtn, menuBtn;
    menuBtn = createMenuBtn();
    addBtn = createAddBtn();
    win.setLeftNavButton(menuBtn);
    win.setRightNavButton(addBtn);
    return win;
  };

  wd.ui.createMainTabGroup = function() {
    var route, routeName, tabGroup, _ref;
    tabGroup = Ti.UI.createTabGroup();
    _ref = wd.routes;
    for (routeName in _ref) {
      route = _ref[routeName];
      wd.ui[routeName + "Tab"] = Ti.UI.createTab({
        window: route.window(),
        tabNum: route.num
      });
      tabGroup.addTab(wd.ui[routeName + "Tab"]);
    }
    return tabGroup;
  };

  wd.ui.createMainView = function() {
    var menuBtn, view;
    view = Ti.UI.createView({
      backgroundColor: "#fff",
      zIndex: 2
    });
    wd.ui.navBar = Ti.UI.createView(_.extend(wd.s.navBar_a));
    menuBtn = createMenuBtn();
    wd.ui.addBtn = createAddBtn();
    wd.ui.navTitle = Ti.UI.createLabel(_.extend(wd.s.navTitle_a, {
      text: "Home"
    }));
    wd.ui.navBar.add(menuBtn);
    wd.ui.navBar.add(wd.ui.addBtn);
    wd.ui.navBar.add(wd.ui.navTitle);
    view.add(wd.ui.navBar);
    wd.ui.tabs.home = wd.ui.createHomeWindow();
    view.add(wd.ui.tabs.home);
    return view;
  };

  wd.ui.showMain = function() {
    wd.ui.menu = wd.ui.createMenu();
    wd.ui.menu.open();
    wd.home.loadHome();
    if (wd.iphone) {
      wd.ui.mainContainer = wd.ui.createMainTabGroup();
      wd.ui.mainContainer.open();
    } else {
      wd.ui.mainContainer = wd.ui.createMainView();
      wd.ui.menu.add(wd.ui.mainContainer);
      wd.ui.initBackButton();
    }
    wd.ui.menu.show();
    if (wd.ui.initContainer) return wd.ui.initContainer.close();
  };

  wd.ui.initBackButton = function() {
    wd.history = [wd.ui.tabs.home];
    return wd.ui.menu.addEventListener("android:back", function() {
      var currView, prevView;
      if (wd.ui.menuOpen) {
        return wd.ui.toggleMenu("close");
      } else {
        if (wd.history.length <= 1) {
          wd.ui.menu.close();
          return Ti.Android.currentActivity.finish();
        } else {
          currView = wd.history.pop();
          prevView = _.last(wd.history);
          prevView.show();
          return currView.hide();
        }
      }
    });
  };

}).call(this);
