(function() {

  wd.ui.createLoginWindow = function() {
    var loginBtn, password, signupBtn, username, win;
    win = Ti.UI.createWindow({
      title: "Login",
      backgroundColor: "#fff",
      tabBarHidden: true,
      navBarHidden: false,
      exitOnClose: true,
      activity: {
        onCreateOptionsMenu: function(e) {
          var signupMenu;
          signupMenu = e.menu.add({
            title: "Sign Up"
          });
          return signupMenu.addEventListener("click", function(e) {
            wd.ui.signupWin = wd.ui.createSignupWindow();
            return wd.ui.signupWin.open();
          });
        }
      }
    });
    username = wd.build.textField({
      hintText: "Username"
    });
    password = wd.build.textField({
      top: 60,
      hintText: "Password",
      passwordMask: true
    });
    loginBtn = wd.build.button({
      title: "Login",
      top: 110
    });
    loginBtn.addEventListener("click", function(e) {
      if (username.value === "" || password.value === "") {
        return alert("Please enter your username and password");
      } else {
        return wd.users.login(username.value.toLowerCase(), password.value);
      }
    });
    if (wd.iphone) {
      signupBtn = wd.build.navBtn({
        title: "Sign Up"
      });
      signupBtn.addEventListener("click", function(e) {
        wd.ui.signupWin = wd.ui.createSignupWindow();
        return wd.loginTab.open(wd.ui.signupWin);
      });
    }
    win.add(username);
    win.add(password);
    win.add(loginBtn);
    if (wd.iphone) win.setRightNavButton(signupBtn);
    return win;
  };

}).call(this);
