(function() {

  wd.ui.createMenu = function() {
    var menuTable, view, win;
    win = Ti.UI.createWindow({
      tabBarHidden: true,
      navBarHidden: true,
      visible: false,
      activity: {
        onPrepareOptionsMenu: function(e) {
          return wd.ui.toggleMenu("open");
        }
      }
    });
    menuTable = Ti.UI.createTableView({
      data: _(wd.routes).reject(function(route) {
        return route.menu === false;
      })
    });
    menuTable.addEventListener("click", function(e) {
      return e.rowData.route();
    });
    wd.ui.menuShadow = Ti.UI.createImageView({
      image: "/img/menushadow.png",
      width: 10,
      height: 480,
      top: 0,
      left: -10
    });
    if (wd.iphone) {
      win.add(menuTable);
      win.add(wd.ui.menuShadow);
    } else {
      view = Ti.UI.createView({
        zIndex: 0
      });
      view.add(menuTable);
      view.add(wd.ui.menuShadow);
      win.add(view);
    }
    return win;
  };

  wd.ui.menuOpen = false;

  wd.ui.toggleMenu = function(direction) {
    if (wd.ui.menuOpen || direction === "close") {
      wd.ui.menuShadow.animate({
        left: -10,
        duration: 300
      });
      wd.ui.mainContainer.animate({
        left: 0,
        top: 0,
        width: 320,
        duration: 300
      });
      wd.ui.menuOpen = false;
      if (wd.iphone) {
        if (wd.ui.closeMenuBtn) {
          return wd.ui.mainContainer.activeTab.window.remove(wd.ui.closeMenuBtn);
        }
      } else {
        if (wd.ui.closeMenuBtn) {
          return wd.ui.mainContainer.remove(wd.ui.closeMenuBtn);
        }
      }
    } else if (!wd.ui.menuOpen || direction === "open") {
      wd.ui.menuShadow.animate({
        left: 265,
        duration: 300
      });
      wd.ui.mainContainer.animate({
        left: 275,
        top: 0,
        width: 320,
        duration: 300
      });
      wd.ui.menuOpen = true;
      wd.ui.closeMenuBtn = Ti.UI.createView({
        zIndex: 99,
        width: 45,
        height: 480,
        top: 0,
        left: 0
      });
      wd.ui.closeMenuBtn.addEventListener("click", function() {
        return wd.ui.toggleMenu("close");
      });
      if (wd.iphone) {
        return wd.ui.mainContainer.activeTab.window.add(wd.ui.closeMenuBtn);
      } else {
        return wd.ui.mainContainer.add(wd.ui.closeMenuBtn);
      }
    }
  };

  wd.ui.showTab = function(tab) {
    var tabName, tabView, _ref;
    wd.info("Showing tab " + tab);
    if (wd.iphone) {
      wd.ui.mainContainer.setActiveTab(wd.ui["" + tab + "Tab"].tabNum);
    } else {
      if (wd.ui.tabs[tab]) {
        wd.ui.tabs[tab].show();
      } else {
        wd.info("Tab not found. Creating " + tab);
        wd.ui.tabs[tab] = wd.routes[tab].window();
        wd.ui.mainContainer.add(wd.ui.tabs[tab]);
      }
      wd.ui.navTitle.text = wd.ui.tabs[tab].title;
      _ref = wd.ui.tabs;
      for (tabName in _ref) {
        tabView = _ref[tabName];
        if (tabName !== tab) tabView.hide();
      }
      wd.ui.updateNavBar(tab);
      wd.history.push(wd.ui.tabs[tab]);
    }
    if (wd.ui.taleShowWin) {
      if (wd.iphone) {
        wd.ui.taleShowWin.close();
      } else {
        wd.ui.taleShowWin.hide();
      }
    }
    return wd.ui.toggleMenu("close");
  };

  wd.ui.openWin = function(win, tab) {
    if (wd.iphone) {
      return tab.open(win);
    } else {
      wd.ui.mainContainer.add(win);
      wd.ui.updateNavBar(win.title);
      return wd.history.push(win);
    }
  };

  wd.ui.updateNavBar = function(title) {
    wd.ui.addBtn.show();
    if (wd.ui.newTaleBtn) wd.ui.newTaleBtn.hide();
    switch (title) {
      case "tales":
        if (wd.ui.newTaleBtn) wd.ui.newTaleBtn.show();
        return wd.ui.addBtn.hide();
    }
  };

}).call(this);
